---
title: Library overview
description: Overview over all libraries that are natively available in LispPad.
order: 6
---

## LispPad

- `(lisppad log)`
- [`(lisppad system)`](7-1-lisppad-system.html)
- [`(lisppad turtle)`](7-2-lisppad-turtle.html)

## LispKit

- `(lispkit base)`
- [`(lispkit core)`](7-4-lispkit-core.html)
- [`(lispkit control)`](7-5-lispkit-control.html)
- [`(lispkit system)`](7-6-lispkit-system.html)
- [`(lispkit box)`](7-7-lispkit-box.html)
- `(lispkit math)`
- [`(lispkit list)`](7-9-lispkit-list.html)
- [`(lispkit hashtable)`](7-10-lispkit-hashtable.html)
- [`(lispkit dynamic)`](7-11-lispkit-dynamic.html)
- [`(lispkit type)`](7-12-lispkit-type.html)
- [`(lispkit vector)`](7-13-lispkit-vector.html)
- [`(lispkit gvector)`](7-14-lispkit-gvector.html)
- `(lispkit record)`
- `(lispkit bytevector)`
- [`(lispkit char)`](7-17-lispkit-char.html)
- [`(lispkit char-set)`](7-18-lispkit-char-set.html)
- [`(lispkit string)`](7-19-lispkit-string.html)
- `(lispkit regexp)`
- `(lispkit port)`
- [`(lispkit date-time)`](7-22-lispkit-date-time.html)
- [`(lispkit draw)`](7-23-lispkit-draw.html)
- [`(lispkit draw turtle)`](7-24-lispkit-draw-turtle.html)
- [`(lispkit datatype)`](7-25-lispkit-datatype.html)
- [`(lispkit object)`](7-26-lispkit-object.html)
- [`(lispkit enum)`](7-27-lispkit-enum.html)
- `(lispkit stream)`
- `(lispkit graph)`
- `(lispkit match)`
- `(lispkit iteration)`
- `(lispkit log)`
- [`(lispkit set)`](7-31-lispkit-set.html)
- `(lispkit stack)`
- `(lispkit queue)`
- `(lispkit heap)`,
- `(lispkit wt-tree)`
- `(lispkit logic)`
- `(lispkit clos)`
- `(lispkit test)`
- `(lispkit prettify)`
- `(lispkit csv)`
- `(lispkit json)`
- `(lispkit pdf)`

## Scheme

### R7RS small

- `(scheme base)`
- `(scheme case-lambda)`
- `(scheme char)`
- `(scheme complex)`
- `(scheme cxr)`,
- `(scheme eval)`
- `(scheme file)`
- `(scheme inexact)`
- `(scheme lazy)`
- `(scheme load)`
- `(scheme process-context)`
- `(scheme read)`
- `(scheme repl)`
- `(scheme time)`
- `(scheme write)`
- `(scheme r5rs)`

### R7RS large

- `(scheme box)`
- `(scheme charset)`
- `(scheme comparator)`
- `(scheme generator)`
- `(scheme hash-table)`
- `(scheme ideque)`
- `(scheme list)`
- `(scheme mapping)`
- `(scheme rlist)`
- `(scheme set)`
- `(scheme sort)`
- `(scheme stream)`
- `(scheme text)`
- `(scheme vector)`

## SRFI

The following  [SRFI](https://srfi.schemers.org/) libraries are available in _LispPad_ natively. Others can be
install manually, typically with very little effort to port the implementation.

- [`(srfi 1)`](../srfi-1.html) [List Library](https://srfi.schemers.org/srfi-1/srfi-1.html)
- [`(srfi 2)`](../srfi-2.html) [AND-LET* - an AND with local bindings, a guarded LET* special form](https://srfi.schemers.org/srfi-2/srfi-2.html)
- [`(srfi 8)`](../srfi-8.html) [receive - Binding to multiple values](https://srfi.schemers.org/srfi-8/srfi-8.html)
- [`(srfi 11)`](../srfi-11.html) [Syntax for receiving multiple values](https://srfi.schemers.org/srfi-11/srfi-11.html)
- [`(srfi 14)`](../srfi-14.html) [Character-set library](https://srfi.schemers.org/srfi-14/srfi-14.html)
- [`(srfi 16)`](../srfi-16.html)  [Syntax for procedures of variable arity](https://srfi.schemers.org/srfi-16/srfi-16.html)
- [`(srfi 17)`](../srfi-17.html) [Generalized set!](https://srfi.schemers.org/srfi-17/srfi-17.html)
- [`(srfi 19)`](../srfi-19.html) [Time Data Types and Procedures](https://srfi.schemers.org/srfi-19/srfi-19.html)
- [`(srfi 23)`](../srfi-23.html) [Error reporting mechanism](https://srfi.schemers.org/srfi-23/srfi-23.html)
- [`(srfi 26)`](../srfi-26.html) [Notation for Specializing Parameters without Currying](https://srfi.schemers.org/srfi-26/srfi-26.html)
- [`(srfi 27)`](../srfi-27.html) [Sources of Random Bits](https://srfi.schemers.org/srfi-27/srfi-27.html)
- [`(srfi 28)`](../srfi-28.html) [Basic Format Strings](https://srfi.schemers.org/srfi-28/srfi-28.html)
- [`(srfi 31)`](../srfi-31.html) [A special form rec for recursive evaluation](https://srfi.schemers.org/srfi-31/srfi-31.html)
- [`(srfi 33)`](../srfi-33.html) [Integer Bitwise-operation Library](https://srfi.schemers.org/srfi-33/srfi-33.html)
- [`(srfi 34)`](../srfi-34.html) [Exception Handling for Programs](https://srfi.schemers.org/srfi-34/srfi-34.html)
- [`(srfi 35)`](../srfi-35.html) [Conditions](https://srfi.schemers.org/srfi-35/srfi-35.html)
- [`(srfi 39)`](../srfi-39.html) [Parameter objects](https://srfi.schemers.org/srfi-39/srfi-39.html)
- [`(srfi 41)`](../srfi-41.html) [Streams](https://srfi.schemers.org/srfi-41/srfi-41.html)
- [`(srfi 46)`](../srfi-46.html) [Basic Syntax-Rules Extensions](https://srfi.schemers.org/srfi-46/srfi-46.html)
- [`(srfi 48)`](../srfi-48.html) [Intermediate Format Strings](https://srfi.schemers.org/srfi-48/srfi-48.html)
- [`(srfi 51)`](../srfi-51.html) [Handling rest list](https://srfi.schemers.org/srfi-51/srfi-51.html)
- [`(srfi 55)`](../srfi-55.html) [`require-extension`](https://srfi.schemers.org/srfi-55/srfi-55.html)
- [`(srfi 63)`](../srfi-63.html) [Homogeneous and Heterogeneous Arrays](https://srfi.schemers.org/srfi-63/srfi-63.html)
- [`(srfi 64)`](../srfi-64.html) [A Scheme API for test suites](https://srfi.schemers.org/srfi-64/srfi-64.html)
- [`(srfi 69)`](../srfi-69.html) [Basic hash tables](https://srfi.schemers.org/srfi-69/srfi-69.html)
- [`(srfi 95)`](../srfi-95.html) [Sorting and Merging](https://srfi.schemers.org/srfi-95/srfi-95.html)
- [`(srfi 101)`](../srfi-101.html) [Purely Functional Random-Access Pairs and Lists](https://srfi.schemers.org/srfi-101/srfi-101.html)
- [`(srfi 111)`](../srfi-111.html) [Boxes](https://srfi.schemers.org/srfi-111/srfi-111.html)
- [`(srfi 112)`](../srfi-112.html) [Environment inquiry](https://srfi.schemers.org/srfi-112/srfi-112.html)
- [`(srfi 113)`](../srfi-113.html) [Sets and bags](https://srfi.schemers.org/srfi-113/srfi-113.html)
- [`(srfi 121)`](../srfi-121.html) [Generators](https://srfi.schemers.org/srfi-121/srfi-121.html)
- [`(srfi 125)`](../srfi-125.html) [Intermediate hash tables](https://srfi.schemers.org/srfi-125/srfi-125.html)
- [`(srfi 128)`](../srfi-128.html) [Comparators](https://srfi.schemers.org/srfi-128/srfi-128.html)
- [`(srfi 129)`](../srfi-129.html) [Titlecase procedures](https://srfi.schemers.org/srfi-129/srfi-129.html)
- [`(srfi 132)`](../srfi-132.html) [Sort Libraries](https://srfi.schemers.org/srfi-132/srfi-132.html)
- [`(srfi 133)`](../srfi-133.html) [Vector Library](https://srfi.schemers.org/srfi-133/srfi-133.html)
- [`(srfi 134)`](../srfi-134.html) [Immutable Deques](https://srfi.schemers.org/srfi-134/srfi-134.html)
- [`(srfi 135)`](../srfi-135.html) [Immutable Texts](https://srfi.schemers.org/srfi-135/srfi-135.html)
- [`(srfi 137)`](../srfi-137.html) [Minimal Unique Types](https://srfi.schemers.org/srfi-137/srfi-137.html)
- [`(srfi 142)`](../srfi-142.html) [Bitwise Operations](https://srfi.schemers.org/srfi-142/srfi-142.html)
- [`(srfi 145)`](../srfi-145.html) [Assumptions](https://srfi.schemers.org/srfi-145/srfi-145.html)
- [`(srfi 145)`](../srfi-146.html) [Mappings](https://srfi.schemers.org/srfi-146/srfi-146.html)
- [`(srfi 151)`](../srfi-151.html) [Bitwise Operations](https://srfi.schemers.org/srfi-151/srfi-151.html)
- [`(srfi 152)`](../srfi-152.html) [String Library](https://srfi.schemers.org/srfi-152/srfi-152.html)
- [`(srfi 158)`](../srfi-158.html) [Generators and Accumulators](https://srfi.schemers.org/srfi-158/srfi-158.html)
- [`(srfi 161)`](../srfi-161.html) [Unifiable Boxes](https://srfi.schemers.org/srfi-161/srfi-161.html)
- [`(srfi 165)`](../srfi-165.html) [The Environment Monad](https://srfi.schemers.org/srfi-165/srfi-165.html)
- [`(srfi 173)`](../srfi-173.html) [Hooks](https://srfi.schemers.org/srfi-173/srfi-173.html)

## Third-party

- `(third-party adapton mini)`
